"use strict";
/* This is a conversion from BLAS to Typescript/Javascript
Copyright (C) 2018  Jacob K.F. Bogers  info@mail.jacob-bogers.com

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
Object.defineProperty(exports, "__esModule", { value: true });
exports.normUpper = void 0;
const f_func_1 = require("../../../f_func");
function normUpper(kx, nounit, x, incx, ap, n) {
    let kk = 1;
    let jx = kx;
    for (let j = 1; j <= n; j++) {
        const xIsZero = x.r[jx - x.base] === 0 && x.i[jx - x.base] === 0;
        if (!xIsZero) {
            const tempRe = x.r[jx - x.base];
            const tempIm = x.i[jx - x.base];
            let ix = kx;
            for (let k = kk; k <= kk + j - 2; k++) {
                const apk = k - ap.base;
                const { re, im } = (0, f_func_1.mul_rxr)(tempRe, tempIm, ap.r[apk], ap.i[apk]);
                x.r[ix - x.base] += re;
                x.i[ix - x.base] += im;
                ix += incx;
            }
            if (nounit) {
                const apk2 = kk + j - 1 - ap.base;
                const { re, im } = (0, f_func_1.mul_rxr)(x.r[jx - x.base], x.i[jx - x.base], ap.r[apk2], ap.i[apk2]);
                x.r[jx - x.base] = re;
                x.i[jx - x.base] = im;
            }
        }
        jx += incx;
        kk += j;
    }
}
exports.normUpper = normUpper;
//# sourceMappingURL=norm-upper.js.map