"use strict";
/* This is a conversion from BLAS to Typescript/Javascript
Copyright (C) 2018  Jacob K.F. Bogers  info@mail.jacob-bogers.com

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
Object.defineProperty(exports, "__esModule", { value: true });
exports.level3 = void 0;
//complex
const cgemm_1 = require("./complex/cgemm");
const chemm_1 = require("./complex/chemm");
const cher2k_1 = require("./complex/cher2k");
const cherk_1 = require("./complex/cherk");
const csymm_1 = require("./complex/csymm");
const csyr2k_1 = require("./complex/csyr2k");
const csyrk_1 = require("./complex/csyrk");
const ctrmm_1 = require("./complex/ctrmm");
const ctrsm_1 = require("./complex/ctrsm");
//single
const sgemm_1 = require("./single/sgemm");
const ssymm_1 = require("./single/ssymm");
const ssyr2k_1 = require("./single/ssyr2k");
const ssyrk_1 = require("./single/ssyrk");
const strmm_1 = require("./single/strmm");
const strsm_1 = require("./single/strsm");
exports.level3 = {
    //single
    sgemm: sgemm_1.sgemm,
    ssymm: ssymm_1.ssymm,
    ssyr2k: ssyr2k_1.ssyr2k,
    ssyrk: ssyrk_1.ssyrk,
    strmm: strmm_1.strmm,
    strsm: strsm_1.strsm,
    //double
    dgemm: sgemm_1.sgemm,
    dsymm: ssymm_1.ssymm,
    dsyr2k: ssyr2k_1.ssyr2k,
    dsyrk: ssyrk_1.ssyrk,
    dtrmm: strmm_1.strmm,
    dtrsm: strsm_1.strsm,
    //complex
    cgemm: cgemm_1.cgemm,
    chemm: chemm_1.chemm,
    cher2k: cher2k_1.cher2k,
    cherk: cherk_1.cherk,
    csymm: csymm_1.csymm,
    csyr2k: csyr2k_1.csyr2k,
    csyrk: csyrk_1.csyrk,
    ctrmm: ctrmm_1.ctrmm,
    ctrsm: ctrsm_1.ctrsm,
    //double complex
    zgemm: cgemm_1.cgemm,
    zhemm: chemm_1.chemm,
    zher2k: cher2k_1.cher2k,
    zherk: cherk_1.cherk,
    zsymm: csymm_1.csymm,
    zsyr2k: csyr2k_1.csyr2k,
    zsyrk: csyrk_1.csyrk,
    ztrmm: ctrmm_1.ctrmm,
    ztrsm: ctrsm_1.ctrsm,
};
//import './doc';
//# sourceMappingURL=index.js.map